// memAlloc.cpp
//
// Colin Harpham  10/05/00
// updated 2007


// All functions cater for 0...n-1 and 1...n 


#include <iostream>
using namespace std;
#include "memAlloc.h"
 
double **matrix2D_real(long rows, long cols)
{
	int i;
	double **m = new double* [rows+1];
	if(!m)
	{
		cout << "Error allocating memory. Quiting" << endl;
		exit(1);
	}

	for (i=0; i<=rows; i++)
		m[i] = new double[cols+1];

	return m;
}

void free_matrix2D_real(double **m, long rows, long cols)
{
	int i;

	for (i=0; i<=rows; i++)
		delete [] m[i];
	delete [] m;
}

double ***matrix3D_real(long rows, long cols, long slices)
{
	int i,j;

	double ***m = new double** [rows+1];
	if(!m)
	{
		cout << "Error allocating memory. Quiting" << endl;
		exit(1);
	}

	for (i=0; i<=rows; i++)
	{
		m[i] = new double*[cols+1];
		for (j=0; j<=cols; j++)
			m[i][j] = new double[slices+1];
	}

	return m;
}

void free_matrix3D_real(double ***m, long rows, long cols, long slices)
{
	int i,j;

	for (i=0; i<=rows; i++)
		for (j=0; j<=cols; j++)
			delete [] m[i][j];
	delete [] m;
}

int **matrix2D_int(long rows, long cols)
{
	int i;

	int **m = new int* [rows+1];
	if(!m)
	{
		cout << "Error allocating memory. Quiting" << endl;
		exit(1);
	}

	for (i=0; i<=rows; i++)
		m[i] = new int[cols+1];

	return m;
}

void free_matrix2D_int(int **m, long rows, long cols)
{
	int i;
	
	for (i=0; i<=rows; i++)
		delete [] m[i];
	delete [] m;
}

int ***matrix3D_int(long rows, long cols, long slices)
{
	int i,j;

	int ***m = new int** [rows+1];
	if(!m)
	{
		cout << "Error allocating memory. Quiting" << endl;
		exit(1);
	}

	for (i=0; i<=rows; i++)
	{
		m[i] = new int*[cols+1];
		for (j=0; j<=cols; j++)
			m[i][j] = new int[slices+1];
	}

	return m;
}

void free_matrix3D_int(int ***m, long rows, long cols, long slices)
{
	int i,j;

	for (i=0; i<=rows; i++)
		for (j=0; j<=cols; j++)
			delete [] m[i][j];
	delete [] m;
}



